<?php
/**
 * @package    miniOrange
 * @subpackage Plugins
 * @license    GNU/GPLv3
 * @copyright  Copyright 2015 miniOrange. All Rights Reserved.
 *
 *
 * This file is part of miniOrange Joomla SAML IDP plugin.
 *
 * miniOrange Joomla SAML IDP plugin is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * miniOrange Joomla IDP plugin is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with miniOrange SAML plugin.  If not, see <http://www.gnu.org/licenses/>.
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted Access');
JHtml::_('jquery.framework');

JHtml::_('stylesheet', JUri::base() .'components/com_joomlaidp/assets/css/miniorange_idp.css');
JHtml::_('stylesheet', JUri::base() .'components/com_joomlaidp/assets/css/bootstrap-tour-standalone.css');
JHtml::_('stylesheet', JUri::base() .'components/com_joomlaidp/assets/css/bootstrap-select-min.css');
JHtml::_('stylesheet', JUri::base() .'components/com_joomlaidp/assets/css/miniorange_boot.css');

JHtml::_('script', JUri::base() . 'components/com_joomlaidp/assets/js/bootstrap-tour-standalone.min.js');
JHtml::_('script', JUri::base() . 'components/com_joomlaidp/assets/js/mo-saml-idp-tour.js');
JHtml::_('script', JUri::base() . 'components/com_joomlaidp/assets/js/bootstrap-select-min.js');
JHtml::_('script', JUri::base() . 'components/com_joomlaidp/assets/js/utilityjs.js');


$tab = JFactory::getApplication()->input->get->getArray();
$idp_active_tab = isset($tab['tab-panel']) ? $tab['tab-panel'] : 'overview';
$test_config = isset($tab['test-config']) ? true : false;
if (MoSamlIdpUtility::is_curl_installed() == 0) { ?>
    <p style="color:red;">
        (Warning:
            <a href="http://php.net/manual/en/curl.installation.php" target="_blank">PHP CURL extension</a>
        is not installed or disabled) Please go to Troubleshooting for steps to enable curl.
    </p>
    <?php
} ?>

<?php
    $session = JFactory::getSession();
    $current_state=$session->get('plugin_Start')==NULL?'false':'true';
    $session->set('show_test_config', false);
    $customer_details = MoSamlIdpUtility::getCustomerDetails();
    if($test_config)
    {
        $session->set('show_test_config', true);
    }
    if($customer_details['show_tc_popup'])
    {
        echo "
        <script>
            jQuery(document).ready(function(){
                show_TC_modal();
            });
        </script>
        ";
        $database_name = '#__miniorange_saml_idp_customer';
        $updatefieldsarray = array(
            'show_tc_popup' => 0,
        );
        IDP_Utilities::updateDatabaseQuery($database_name, $updatefieldsarray);
    }
    if($customer_details['show_tc_popup']==0 && $customer_details['initialise_visual_tour']==1)
    {
        echo "
        <script>
            jQuery(document).ready(function(){
                restart_tabtour();
            });
        </script>
        ";
        $database_name = '#__miniorange_saml_idp_customer';
        $updatefieldsarray = array(
            'initialise_visual_tour' => 0,
        );
        IDP_Utilities::updateDatabaseQuery($database_name, $updatefieldsarray);
    }
?>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.0/js/bootstrap.min.js"></script>
<div class="mo_boot_container-fluid" style="margin-top:10px">
    <div class="mo_boot_row">
        <div class="mo_boot_col-lg-9 mo_boot_p-0">
            <div class="nav-tab-wrapper mo_idp_nav-tab-wrapper">

                <a id="overviewtab" class="mo_nav-tab <?php echo $idp_active_tab == 'overview' ? 'mo_nav_tab_active' : ''; ?>" href="#overview_plugin"
                onclick="add_css_tab('#overviewtab');"
                data-toggle="tab"><?php echo JText::_('COM_JOOMLAIDP_TAB1_OVERVIEW'); ?>
                </a>

                <a id="sptab" class="mo_nav-tab <?php echo $idp_active_tab == 'sp' ? 'mo_nav_tab_active' : ''; ?>" href="#service-provider"
                onclick="add_css_tab('#sptab');"
                data-toggle="tab"><?php echo JText::_('COM_JOOMLAIDP_TAB3_SERVICE_PROVIDER'); ?>
                </a>

                <a id="idptab" class="mo_nav-tab <?php echo $idp_active_tab == 'idp' ? 'mo_nav_tab_active' : ''; ?>" href="#identity-provider"
                onclick="add_css_tab('#idptab');"
                data-toggle="tab"><?php echo JText::_('COM_JOOMLAIDP_TAB4_IDENTITY_PROVIDER'); ?>
                </a>

                <a id="advance_mapping_tab" class="mo_nav-tab <?php echo $idp_active_tab == 'advance_mapping' ? 'mo_nav_tab_active' : ''; ?>" href="#iadvance_mapping"
                onclick="add_css_tab('#advance_mapping_tab');"
                data-toggle="tab"><?php echo JText::_('COM_JOOMLAIDP_MAPPING'); ?>
                </a>

                <a id="rolerelay_restiction" class="mo_nav-tab <?php echo $idp_active_tab == 'role_relay_restriciton' ? 'mo_nav_tab_active' : ''; ?>" href="#role_relay_restriciton_id"
                onclick="add_css_tab('#rolerelay_restiction');"
                data-toggle="tab"><?php echo JText::_('COM_JOOMLAIDP_RELAY_RESTRICTION_TAB_NAME'); ?>
                </a>

                <a id="signin_settings_tab" class="mo_nav-tab <?php echo $idp_active_tab == 'signin_settings' ? 'mo_nav_tab_active' : ''; ?>" href="#signin_settings_id"
                onclick="add_css_tab('#signin_settings_tab');"
                data-toggle="tab"><?php echo JText::_('COM_JOOMLAIDP_SIGNIN_SETTINGS'); ?>
                </a>

                <a id="licensingtab" class="mo_nav-tab <?php echo $idp_active_tab == 'license' ? 'mo_nav_tab_active' : ''; ?>" href="#licensing-plans"
                onclick="add_css_tab('#licensingtab');"
                data-toggle="tab"><?php echo JText::_('COM_JOOMLAIDP_TAB6_LICENSING_PLANS'); ?>
                </a>

             
               
            </div>
        </div>
        <div class="mo_boot_col-lg-3">
            <input type="button" id="end_tab_tour" value="Start Plugin Tour" onclick="restart_tabtour();" style=" float: right;margin:5px" class="mo_boot_btn mo_boot_btn-saml"/>
            <button id="mo_TC"  onclick="show_TC_modal()" style=" float: right;margin:5px" class="mo_boot_btn mo_boot_btn-saml">T&C</button>
            <div id="my_TC_Modal" class="TC_modal">
                <div class="TC_modal-content">
                    <div class="mo_boot_col-12 mo_boot_text-center">
                        <span style="font-size: 28px;"><strong>Terms & Condition</strong></span>
                        <span class="TC_modal_close" onclick="MyClose()">&times;</span>
                    </div>
                    <div>
                        <hr>
                        <ul> 
                            <li>1. We'll be sending the email to your admin email to get in touch with you if you have any issues while testing our plugin.</li>
                            <li>2. Your email address will not be shared or used by any third parties. The main aim of picking an email address is to connect with you.</li>
                            <li>3. You can update your email address below if you like. So that if you require assistance, we can contact you at your correct email address.</li>
                            <li>4. If you require any assistance, you may contact us at <strong>joomlasupport@xecurify.com</strong>.</li>
                            <li>
                                <form method="post" name="f" action="<?php echo JRoute::_('index.php?option=com_joomlaidp&view=accountsetup&task=accountsetup.saveAdminMail'); ?>" > 
                                    <?php
                                        $dVar=new JConfig(); 
                                        $check_email = $dVar->mailfrom;
                                        $result = IDP_Utilities::fetchDatabaseValues('#__miniorange_saml_idp_customer', 'loadAssoc', '*');
                                
                                        if($result['email']!=NULL)
                                        {
                                            $check_email =$result['email'];
                                        }
                                    ?>
                                    <div class="mo_boot_row mo_boot_mt-3">
                                        <div class="mo_boot_col-sm-5">
                                            <input type="email" name="admin_email"  class="mo_boot_form-control" value="<?php echo $check_email;?>">
                                        </div>
                                        <div class="mo_boot_col-sm-3">
                                            <input type="submit" class="mo_boot_btn mo_boot_btn-primary">
                                        </div>
                                    </div>                            
                                </form>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="mo_boot_row"  style="background-color:#e0e0d8; padding:15px;">
        <div class="mo_boot_col-sm-12">
                <div class="tab-content" id="myTabContent">

                    <div id="overview_plugin" class="tab-pane <?php echo $idp_active_tab == 'overview' ? 'active' : '';?>"> <?php
                        $class_name = "JoomlaIdpViewAccountSetup";
                        $func_name = "showPluginOverview";
                        common_classes_for_UI_1($class_name, $func_name,'mo_saml_idp_support');?>
                    </div>

                    <div id="service-provider" class="tab-pane <?php echo $idp_active_tab == 'sp' ? 'active' : '';?>"> <?php
                        $class_name = "JoomlaIdpViewAccountSetup";
                        $func_name = "showServiceProviderConfigurations";
                        common_classes_for_UI_1($class_name, $func_name,'mo_saml_idp_support');?>
                    </div>

                    <div id="identity-provider" class="tab-pane <?php echo $idp_active_tab == 'idp' ? 'active' : ''; ?>"> <?php
                        $class_name = "JoomlaIdpViewAccountSetup";
                        $func_name = "showIdentityProviderConfigurations";
                        common_classes_for_UI_1($class_name, $func_name,'mo_saml_idp_support');?>
                    </div>

                    <div id="iadvance_mapping" class="tab-pane <?php echo $idp_active_tab == 'advance_mapping' ? 'active' : ''; ?>"> <?php
                        $class_name = "JoomlaIdpViewAccountSetup";
                        $func_name = "showAdvanceMapping";
                        common_classes_for_UI_1($class_name, $func_name,'mo_saml_idp_support');?>
                    </div>

                    <div id="role_relay_restriciton_id" class="tab-pane <?php echo $idp_active_tab == 'role_relay_restriciton' ? 'active' : ''; ?>"> <?php
                        $class_name = "JoomlaIdpViewAccountSetup";
                        $func_name = "showRoleRelayRestriction";
                        common_classes_for_UI_1($class_name, $func_name,'mo_advertise_2fa');?>
                    </div>

                    <div id="signin_settings_id" class="tab-pane <?php echo $idp_active_tab == 'signin_settings' ? 'active' : ''; ?>"> <?php
                        $class_name = "JoomlaIdpViewAccountSetup";
                        $func_name = "showIDPInitiatedLoginDetails";
                        common_classes_for_UI_1($class_name, $func_name,'mo_advertise_2fa');?>
                    </div>

                   <!-- <div id="custom_certificate_id" class="tab-pane <?php /*echo $idp_active_tab == 'custom_certificate' ? 'active' : ''; */?>"> <?php
/*                        $class_name = "JoomlaIdpViewAccountSetup";
                        $func_name = "custom_certificate";
                        common_classes_for_UI_1($class_name, $func_name,'mo_saml_idp_support');*/?>
                    </div>-->

                    <div id="licensing-plans" class="tab-pane <?php echo $idp_active_tab == 'license' ? 'active' : ''; ?>">
                        <div class="mo_saml_table_layout_1">
                            <div class="mo_saml_table_layout mo_saml_container_pricing">
                                    <?php
                                        $result      = IDP_Utilities::fetchDatabaseValues('#__miniorange_saml_idp_customer', 'loadAssoc','*');
                                        $email       = isset($result['email']) ? $result['email'] : '';
                                        $hostName    = MoSamlIdpUtility::getHostName();
                                        $loginUrl    = $hostName . '/moas/login';
                                        $redirectUrl = $hostName . '/moas/initializepayment';
                                        echo $this->showLicensingPlanDetails();
                                    ?>
                            </div>
                        </div>
                        <form id="idp_default_form" method="post"
                            action="<?php echo JRoute::_('index.php?option=com_joomlaidp&view=samlidpsettings'); ?>">
                        </form>
                        <form style="display:none;" id="moidp_loginform" action="<?php echo $loginUrl; ?>" target="_blank"
                            method="post">
                            <input name="username" value="<?php echo $email; ?>" type="email" style="display:none;">
                            <input name="redirectUrl" value="<?php echo $redirectUrl; ?>" type="hidden">
                            <input name="requestOrigin" id="requestOrigin" type="hidden">
                        </form>
                    </div>
                    <div id="request-demo" class="tab-pane <?php if ($tab == 'request_demo') echo 'active'; ?>">
                    <?php
                        $class_name = "JoomlaIdpViewAccountSetup";
                        $func_name = "requestfordemo";
                        common_classes_for_UI_1($class_name, $func_name,'mo_advertise_2fa');?>
                </div>
                </div>
        </div>
    </div>
    <!--
        *End Of Tabs for accountsetup view.
        *Below are the UI for various sections of Account Creation.
    -->
</div>
<?php
        function common_classes_for_UI($tab_func, $support_func)
        {
            ?>
                <div class="mo_boot_row mo_boot_ml-1">
                    <div class="mo_boot_col-lg-8 mo_boot_mt-2 " >
                        <div>
                            <?php
                                $tab_func();
                            ?>
                        </div>
                    </div>
                    <div class="mo_boot_col-lg-4 mo_boot_mt-2">
                        <div id="mo_saml_support1" style="border: 2px solid rgb(15, 127, 182);background-color:white">
                            <?php
                               $support_func();
                            ?>
                        </div>
                    </div>
                </div>
            <?php
        }

        function common_classes_for_UI_1($class_name, $method, $support_func)
        {
            ?>
                <div class="mo_boot_row  mo_boot_ml-1">
                    <div class="mo_boot_col-lg-8 mo_boot_mt-2 " >
                        <div>
                            <?php
                                $ClassType = $class_name;
                                call_user_func(array($ClassType, $method));
                            ?>
                        </div>
                    </div>
                    <div class="mo_boot_col-lg-4 mo_boot_mt-2">
                        <div id="mo_saml_support1" style="border: 2px solid rgb(15, 127, 182);background-color:white">
                            <?php
                             $support_func();
                            ?>
                        </div>
                    </div>
                </div>
            <?php
        }


        function mo_saml_idp_support()
        {
            $strJsonFileContents = file_get_contents(__DIR__ . '/../../../assets/json/timezones.json'); 
            
            $timezoneJsonArray = json_decode($strJsonFileContents, true);
            $current_user = JFactory::getUser();
            $result       = IDP_Utilities::fetchDatabaseValues('#__miniorange_saml_idp_customer', 'loadAssoc', '*');
            $admin_email  = isset($result['email']) ? $result['email'] : '';
            $admin_phone  = isset($result['admin_phone']) ? $result['admin_phone'] : '';

            if ($admin_email == '' || empty($admin_email))
                $admin_email = $current_user->email;
            ?>
                <div class="mo_boot_row mo_boot_p-4 mo_saml_support" id="mo_saml_support" >
                    <div class="mo_boot_col-sm-12">
                        <div class="mo_boot_row">
                            <h3><?php echo JText::_('COM_JOOMLAIDP_SUPPORT_HEADER'); ?></h3>
                        </div>
                        <hr>
                    </div>
                   
                    <div class="mo_boot_col-sm-12">	
                        <div class="mo_boot_row ">
						    <img src="<?php echo JUri::base();?>/components/com_joomlaidp/assets/images/phone.svg" width="27" height="27"  alt="Phone Image">
                            <p><?php echo JText::_('COM_JOOMLAIDP_SUPPORT_DESCRIPTION'); ?></p><br>
						</div>
					</div>
                    <div class="mo_boot_col-sm-12" id="idp_support">
                        <form name="f" method="post" action="<?php echo JRoute::_('index.php?option=com_joomlaidp&view=accountsetup&task=accountsetup.contactUs'); ?>">
                            <input type="email" class="mo_boot_form-control" name="mo_saml_query_email" value="<?php echo $admin_email; ?>" placeholder="<?php echo JText::_('COM_JOOMLAIDP_EMAIL_TITLE'); ?>" required/><br>
                            <input type="text" pattern="[\+][0-9]{7,15}" class="mo_boot_form-control" name="mo_saml_query_phone" value="<?php echo $admin_phone; ?>" placeholder="<?php echo JText::_('COM_JOOMLAIDP_EMAIL_PLACEHOLDER'); ?>"/><br>
                            <textarea name="mo_saml_query"  style="border-radius:4px;resize: vertical;width:100%; border: 1px solid #868383!important;" cols="52" rows="5" placeholder="<?php echo JText::_('COM_JOOMLAIDP_QUERY_PLACEHOLDER'); ?>" required></textarea>
                            <div class="mo_boot_row mo_boot_text-center">
                                <div class="mo_boot_col-sm-12">
                                    <input type="hidden" name="option1" value="mo_saml_login_send_query"/><br>
                                    <input type="submit" name="send_query" value="<?php echo JText::_('COM_JOOMLAIDP_QUERY_BTN'); ?>" class="mo_boot_btn mo_boot_btn-success"  style="margin-top:5px"/>
                                    <input type="button" onclick="window.open('https://faq.miniorange.com/kb/joomla/')" target="_blank" value="<?php echo JText::_('COM_JOOMLAIDP_FAQ'); ?>" class="mo_boot_btn mo_boot_btn-saml" style="margin-top:5px">
                                    <input type="button" onclick="window.open('https://forum.miniorange.com/')" target="_blank" value="<?php echo JText::_('COM_JOOMLAIDP_ASK_FORUM'); ?>"   class="mo_boot_btn mo_boot_btn-saml" style="margin-top:5px">
                                </div>
					        </div><hr>
                        </form>
                    </div>
                    <div class="mo_boot_col-sm-12">
                        <p><br><?php echo JText::_('COM_JOOMLAIDP_SUPPORT'); ?>
                            <a href="mailto:joomlasupport@xecurify.com"><i style="word-wrap:break-word">joomlasupport@xecurify.com</i></a>
                        </p>
                    </div>
                </div>
             
            <?php
        }


        function mo_advertise_2fa()
        {
            ?>


            <form name="f2" class="mo_boot_p-3">
                <h5 style="text-align: center;"><?php echo JText::_('COM_JOOMLAIDP_TFA_ADD'); ?></h5>
                <div class="mo_boot_row ">
                    <div class="mo_boot_col-sm-12">
                        <div class="mo_boot_text-center">
                                <img src="<?php echo JURI::root(); ?>administrator/components/com_joomlaidp/assets/images/2fa.png" alt="miniOrange icon" height=80% width=80%>
                        </div>   
                        <div class="mo_boot_row">
                            <div class="mo_boot_col-sm-2">
                                <img src="<?php echo JURI::root(); ?>administrator/components/com_joomlaidp/assets/images/miniorange.png" alt="miniOrange icon" height=25px width=25px>
                            </div>  
                            <div class="mo_boot_col-sm-10">    
                                <h4><?php echo JText::_('COM_JOOMLAIDP_TFA_HEDAER'); ?></h4>
                            </div>
                        </div> 
                            <br>
                            <p style="text-align: center;font-size:14px"><?php echo JText::_('COM_JOOMLAIDP_TFA_DESCRIPTION'); ?></p>
                    </div>
                </div><br>
                <div class="mo_boot_row mo_boot_text-center">
                    <div class="mo_boot_col-sm-12">
                        <a href="https://prod-marketing-site.s3.amazonaws.com/plugins/joomla/joomla-2fa-plugin.zip" class="mo_boot_btn mo_boot_btn-saml" style="margin-top:5px"><?php echo JText::_('COM_JOOMLAIDP_DOWNLOAD_PLUGIN'); ?></a>
                        <a href="https://plugins.miniorange.com/joomla-two-factor-authentication-2fa"  class="mo_boot_btn mo_boot_btn-success"  style="margin-top:5px" target="_blank"><?php echo JText::_('COM_JOOMLAIDP_KNOW_MORE'); ?></a>
                    </div>
                </div>
            </form>

            <?php
        }

           
            
    ?>
